com.io7m.smfj.validation.api

## Interface SMFSchemaType

- All Known Implementing Classes:
    SMFSchema

      public interface SMFSchemaType

  The type of schemas.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `allowExtraAttributes()`
    `default void` | `checkPreconditions()` Check preconditions for the type.
    `javaslang.collection.SortedMap<SMFAttributeName,SMFSchemaAttribute>` | `optionalAttributes()` A schema may define optional attributes.
    `javaslang.collection.SortedMap<SMFAttributeName,SMFSchemaAttribute>` | `requiredAttributes()` A schema may define required attributes.
    `Optional<SMFCoordinateSystem>` | `requiredCoordinateSystem()`
    `SMFSchemaIdentifier` | `schemaIdentifier()`

- - ### Method Detail

    - #### schemaIdentifier

          SMFSchemaIdentifier schemaIdentifier()

      Returns:
        The unique schema identifier

    - #### requiredAttributes

          javaslang.collection.SortedMap<SMFAttributeName,SMFSchemaAttribute> requiredAttributes()

      A schema may define required attributes. An attribute is not allowed to be both required and optional at the same time.
      Returns:
        The required attributes

    - #### optionalAttributes

          javaslang.collection.SortedMap<SMFAttributeName,SMFSchemaAttribute> optionalAttributes()

      A schema may define optional attributes. An attribute is not allowed to be both required and optional at the same time.
      Returns:
        The optional attributes

    - #### requiredCoordinateSystem

          Optional<SMFCoordinateSystem> requiredCoordinateSystem()

      Returns:
        The required coordinate system, if any

    - #### allowExtraAttributes

          boolean allowExtraAttributes()

      Returns:
        `true` iff the mesh is allowed to contain attributes that are not given in `requiredAttributes()`

    - #### checkPreconditions

          default void checkPreconditions()

      Check preconditions for the type.

Copyright © 2017 <code@io7m.com> http://io7m.com